=== debian/changelog ===
crunch-dxtc (0.55.5-1) unstable; urgency=medium

  * Initial release.  (Closes: #1110428)

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 22 Oct 2025 10:34:46 +0200
