=== debian/control ===
Source: crunch-dxtc
Section: graphics
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.7.2
Homepage: https://github.com/DaemonEngine/crunch
Vcs-Browser: https://salsa.debian.org/twolife/crunch-dxtc
Vcs-Git: https://salsa.debian.org/twolife/crunch-dxtc.git

Package: crunch-dxtc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Advanced DXTc texture compression and transcoding tool
 crunch is an open source lossy texture compression command line
 tool for developers that distribute and use content in the DXT1/5/N or
 3DC/BC5 compressed mipmapped GPU texture formats.
