=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

execute_after_dh_auto_install:
	mv debian/crunch-dxtc/usr/bin/crunch debian/crunch-dxtc/usr/bin/crunch-dxtc
