=== debian/watch ===
Version: 5
Template: Github
Owner: DaemonEngine
Project: crunch
Matching-Pattern: https://api.github.com/repos/DaemonEngine/crunch/git/refs/tags/unvanquished/@ANY_VERSION@
